Index: base/applications/games/solitaire/lang/tr-TR.rc
===================================================================
--- base/applications/games/solitaire/lang/tr-TR.rc	(révision 58413)
+++ base/applications/games/solitaire/lang/tr-TR.rc	(copie de travail)
@@ -4,7 +4,7 @@
  * FILE:        base/applications/games/solitaire/lang/tr-TR.rc
  * PURPOSE:     Turkish Language File for Solitaire
  * PROGRAMMERS: Daniel "EmuandCo" Reimer (reimer.daniel@freenet.de)
- * TRANSLATOR:  Erdem ERSOY (eersoy93)
+ * TRANSLATOR:  Erdem Ersoy (eersoy93)
  */
 
 LANGUAGE LANG_TURKISH, SUBLANG_DEFAULT
@@ -18,10 +18,10 @@
 FONT 8, "MS Shell Dlg"
 BEGIN
     GROUPBOX        "Kağıtlar", -1, 7, 7, 90, 40
-    AUTORADIOBUTTON "&Tekli çekme", IDC_OPT_DRAWONE, 14, 19, 70, 10, WS_GROUP | WS_TABSTOP
-    AUTORADIOBUTTON "&Üçlü çekme", IDC_OPT_DRAWTHREE, 14, 32, 70, 10
+    AUTORADIOBUTTON "&Tekli çek", IDC_OPT_DRAWONE, 14, 19, 70, 10, WS_GROUP | WS_TABSTOP
+    AUTORADIOBUTTON "&Üçlü çek", IDC_OPT_DRAWTHREE, 14, 32, 70, 10
 
-    AUTOCHECKBOX    "&Zamanı göster", IDC_OPT_SHOWTIME, 7 ,51 ,65 ,10, WS_TABSTOP | WS_DISABLED
+    AUTOCHECKBOX    "&Süreyi göster", IDC_OPT_SHOWTIME, 7 ,51 ,65 ,10, WS_TABSTOP | WS_DISABLED
     AUTOCHECKBOX    "&Durum çubuğu", IDC_OPT_STATUSBAR, 7, 66, 64, 10, WS_TABSTOP
 
     DEFPUSHBUTTON   "Tamam", IDOK, 35, 97, 50, 14
Index: base/applications/games/spider/lang/tr-TR.rc
===================================================================
--- base/applications/games/spider/lang/tr-TR.rc	(révision 58413)
+++ base/applications/games/spider/lang/tr-TR.rc	(copie de travail)
@@ -3,7 +3,7 @@
  * LICENSE:      See COPYING in top level directory
  * FILE:         base/applications/games/spider/lang/tr-TR.rc
  * PURPOSE:      Turkish Language File for Spider Solitaire
- * TRANSLATOR:   Erdem ERSOY (eersoy93)
+ * TRANSLATOR:   Erdem Ersoy (eersoy93)
  */
 
 LANGUAGE LANG_TURKISH, SUBLANG_DEFAULT
Index: base/applications/games/winmine/lang/tr-TR.rc
===================================================================
--- base/applications/games/winmine/lang/tr-TR.rc	(révision 58413)
+++ base/applications/games/winmine/lang/tr-TR.rc	(copie de travail)
@@ -2,7 +2,8 @@
  * WineMine
  * Turkish Language Support
  *
- * Copyright 2006 Fatih Aþýcý
+ * Copyright 2006 Fatih Aşıcı
+ * Copyright 2013 Erdem Ersoy (eersoy93)
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
@@ -22,40 +23,40 @@
 LANGUAGE LANG_TURKISH, SUBLANG_DEFAULT
 
 STRINGTABLE BEGIN
-     IDS_APPNAME, "Wine Mayýn Tarlasý"
+     IDS_APPNAME, "Wine Mayın Tarlası"
      IDS_NOBODY,  "Hiç kimse"
-     IDS_ABOUT,   "Telif hakký 2000, Joshua Thielen"
+     IDS_ABOUT,   "Telif hakkı: Joshua Thielen, 2000"
 END
 
 MENU_WINEMINE MENU
 BEGIN
     POPUP "&Seçenekler" BEGIN
-        MENUITEM "&Yeni\tF2",      IDM_NEW
+        MENUITEM "&Yeni\tF2",        IDM_NEW
         MENUITEM SEPARATOR
-        MENUITEM "&Soru Ýþareti",  IDM_MARKQ
+        MENUITEM "&Soru İmi",        IDM_MARKQ
         MENUITEM SEPARATOR
-        MENUITEM "&Acemi",         IDM_BEGINNER
-        MENUITEM "&Geliþmiþ",      IDM_ADVANCED
-        MENUITEM "&Uzman",         IDM_EXPERT
-        MENUITEM "&Özel",          IDM_CUSTOM
+        MENUITEM "&Başlangıç",       IDM_BEGINNER
+        MENUITEM "&Orta",            IDM_ADVANCED
+        MENUITEM "&İleri",           IDM_EXPERT
+        MENUITEM "&Özel",            IDM_CUSTOM
         MENUITEM SEPARATOR
-        MENUITEM "&Çýkýþ\tAlt+X",  IDM_EXIT
+        MENUITEM "&Çıkış\tAlt+X",    IDM_EXIT
     END
     POPUP "&Bilgi" BEGIN
-        MENUITEM "&En Kýsa Süreler",    IDM_TIMES
-        MENUITEM "&Hakkýnda",      IDM_ABOUT
+        MENUITEM "&En Kısa Süreler", IDM_TIMES
+        MENUITEM "&Hakkında",        IDM_ABOUT
     END
 END
 
 DLG_TIMES DIALOGEX 0, 0, 160, 80
 STYLE  DS_MODALFRAME | WS_VISIBLE | WS_CAPTION | WS_SYSMENU | WS_POPUP | DS_SHELLFONT
-CAPTION "En Kýsa Süreler"
+CAPTION "En Kısa Süreler"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    GROUPBOX        "En Kýsa Süreler", -1,  10,  10, 140,  45
-    LTEXT           "Acemi",           -1,  20,  20,  40,   8
-    LTEXT           "Geliþmiþ",        -1,  20,  30,  40,   8
-    LTEXT           "Uzman",           -1,  20,  40,  40,   8
+    GROUPBOX        "En Kısa Süreler", -1,  10,  10, 140,  45
+    LTEXT           "Başlangıç",       -1,  20,  20,  40,   8
+    LTEXT           "Orta",            -1,  20,  30,  40,   8
+    LTEXT           "İleri",           -1,  20,  40,  40,   8
     LTEXT           "999",          IDC_TIME1,  70,  20,  15,   8
     LTEXT           "999",          IDC_TIME2,  70,  30,  15,   8
     LTEXT           "999",          IDC_TIME3,  70,  40,  15,   8
@@ -70,9 +71,9 @@
 CAPTION "Tebrikler!"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    LTEXT           "Lütfen adýnýzý girin", -1,  10,  10, 150,  10
+    LTEXT           "Lütfen adınızı giriniz:", -1,  10,  10, 150,  10
     EDITTEXT                              IDC_EDITNAME,  25,  20, 110,  12
-    DEFPUSHBUTTON   "Tamam",                         IDOK,  60,  40,  40,  15
+    DEFPUSHBUTTON   "Tamam",                      IDOK,  60,  40,  40,  15
 END
 
 DLG_CUSTOM DIALOGEX  0, 0, 100, 100
@@ -80,12 +81,12 @@
 CAPTION "Özel Oyun"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    LTEXT           "Satýrlar",   -1,   5,   5,  30,  10
+    LTEXT           "Satırlar",   -1,   5,   5,  30,  10
     LTEXT           "Sütunlar",   -1,   5,  35,  30,  10
-    LTEXT           "Mayýnlar",   -1,   5,  65,  30,  10
+    LTEXT           "Mayınlar",   -1,   5,  65,  30,  10
     EDITTEXT              IDC_EDITROWS,   5,  15,  20,  12, ES_NUMBER
     EDITTEXT              IDC_EDITCOLS,   5,  45,  20,  12, ES_NUMBER
     EDITTEXT             IDC_EDITMINES,   5,  75,  20,  12, ES_NUMBER
-    DEFPUSHBUTTON   "Tamam",     IDOK,      40,  30,  50,  15
-    PUSHBUTTON      "Ýptal", IDCANCEL,  40,  50,  50,  15
+    DEFPUSHBUTTON   "Tamam",  IDOK,      40,  30,  50,  15
+    PUSHBUTTON      "Vazgeç", IDCANCEL,  40,  50,  50,  15
 END
Index: base/applications/games/winmine/lang/uk-UA.rc
===================================================================
--- base/applications/games/winmine/lang/uk-UA.rc	(révision 58413)
+++ base/applications/games/winmine/lang/uk-UA.rc	(copie de travail)
@@ -1,5 +1,4 @@
 /*
-/*
  * WineMine
  * Ukrainian Language Support
  *