Index: base/applications/mplay32/lang/en-US.rc
===================================================================
--- base/applications/mplay32/lang/en-US.rc	(revision 58545)
+++ base/applications/mplay32/lang/en-US.rc	(working copy)
@@ -4,20 +4,20 @@
 BEGIN
 	POPUP "&File"
 	BEGIN
-		MENUITEM "&Open...", IDM_OPEN_FILE
-		MENUITEM "&Close", IDM_CLOSE_FILE
+		MENUITEM "&Open",     IDM_OPEN_FILE
+		MENUITEM "&Close",    IDM_CLOSE_FILE
 		MENUITEM SEPARATOR
-		MENUITEM "&Exit", IDM_EXIT
+		MENUITEM "&Exit",     IDM_EXIT
 	END
 	POPUP "&Help"
 	BEGIN
-		MENUITEM "&About...", IDM_ABOUT
+		MENUITEM "&About",    IDM_ABOUT
 	END
 END
 
 STRINGTABLE DISCARDABLE
 BEGIN
-	IDS_ALL_TYPES_FILTER "All Supported (*.wav, *.cda, *.midi, *.mid, *.avi)\0*.wav;*.cda;*.midi;*.mid;*.avi\0"
+	IDS_ALL_TYPES_FILTER "All Supported Files (*.wav, *.cda, *.mid, *.midi, *.avi)\0*.wav;*.cda;*.mid;*.midi;*.avi\0"
 	IDS_TOOLTIP_PLAY "Play"
 	IDS_TOOLTIP_STOP "Stop"
 	IDS_TOOLTIP_EJECT "Eject"
Index: base/applications/mplay32/lang/tr-TR.rc
===================================================================
--- base/applications/mplay32/lang/tr-TR.rc	(revision 0)
+++ base/applications/mplay32/lang/tr-TR.rc	(working copy)
@@ -0,0 +1,30 @@
+LANGUAGE LANG_TURKISH, SUBLANG_DEFAULT
+
+IDR_MAINMENU MENU
+BEGIN
+	POPUP "&Kütük"
+	BEGIN
+		MENUITEM "&Aç",       IDM_OPEN_FILE
+		MENUITEM "&Kapat",    IDM_CLOSE_FILE
+		MENUITEM SEPARATOR
+		MENUITEM "&Çıkış",    IDM_EXIT
+	END
+	POPUP "&Yardım"
+	BEGIN
+		MENUITEM "&Hakkında", IDM_ABOUT
+	END
+END
+
+STRINGTABLE DISCARDABLE
+BEGIN
+	IDS_ALL_TYPES_FILTER "Tüm Desteklenen Dosyalar (*.wav, *.cda, *.mid, *.midi, *.avi)\0*.wav;*.cda;*.mid;*.midi;*.avi\0"
+	IDS_TOOLTIP_PLAY "Çal"
+	IDS_TOOLTIP_STOP "Durdur"
+	IDS_TOOLTIP_EJECT "Çıkar"
+	IDS_TOOLTIP_BACKWARD "Bir Önceki"
+	IDS_TOOLTIP_SEEKBACK "Geri Sar"
+	IDS_TOOLTIP_SEEKFORW "İleri Sar"
+	IDS_TOOLTIP_FORWARD "Bir Sonraki"
+	IDS_APPTITLE "ReactOS Çokluortam Oynatıcısı"
+	IDS_PLAY "Çal"
+END
Index: base/applications/mplay32/rsrc.rc
===================================================================
--- base/applications/mplay32/rsrc.rc	(revision 58545)
+++ base/applications/mplay32/rsrc.rc	(working copy)
@@ -51,6 +51,9 @@
 #ifdef LANGUAGE_SV_SE
     #include "lang/sv-SE.rc"
 #endif
+#ifdef LANGUAGE_TR_TR
+    #include "lang/tr-TR.rc"
+#endif
 #ifdef LANGUAGE_UK_UA
     #include "lang/uk-UA.rc"
 #endif
Index: base/applications/sndrec32/lang/en-US.rc
===================================================================
--- base/applications/sndrec32/lang/en-US.rc	(revision 58545)
+++ base/applications/sndrec32/lang/en-US.rc	(working copy)
@@ -8,37 +8,37 @@
 
 IDD_ABOUTBOX DIALOGEX 0, 0, 196, 75
 STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
-CAPTION "Information about ReactOS Sound Recorder"
+CAPTION "About ReactOS Sound Recorder"
 FONT 8, "MS Shell Dlg", 0, 0, 0x1
 BEGIN
     ICON            IDI_SNDREC32,-1,19,14,21,20
     LTEXT           "ReactOS Sound Recorder, version 1.0",IDC_STATIC,56,16,114,8,SS_NOPREFIX
-    LTEXT           "Copyright (C) 2009",IDC_STATIC,55,25,114,8
-    DEFPUSHBUTTON   "OK",IDOK,139,54,50,14,WS_GROUP
+    LTEXT           "Copyright (C) - 2009",IDC_STATIC,55,25,114,8
+    DEFPUSHBUTTON   "&OK",IDOK,139,54,50,14,WS_GROUP
 END
 
 IDR_MENU1 MENU
 BEGIN
-    POPUP "File"
+    POPUP "&File"
     BEGIN
-        MENUITEM "New",                         ID_NEW
-        MENUITEM "Open...",                     ID_FILE_OPEN
-        MENUITEM "Save",                        ID_FILE_SAVE, GRAYED
-        MENUITEM "Save As...",                  ID_FILE_SAVEAS, GRAYED
+        MENUITEM "&New",                     ID_NEW
+        MENUITEM "&Open",                    ID_FILE_OPEN
+        MENUITEM "&Save",                    ID_FILE_SAVE, GRAYED
+        MENUITEM "Save &As",                 ID_FILE_SAVEAS, GRAYED
         MENUITEM SEPARATOR
-        MENUITEM "Exit",                        ID_EXIT
+        MENUITEM "&Exit",                    ID_EXIT
     END
-    MENUITEM "todo1",                       0
-    MENUITEM "todo2",                       0
-    POPUP "?"
+    MENUITEM "todo1",                        0
+    MENUITEM "todo2",                        0
+    POPUP "&Help"
     BEGIN
-        MENUITEM "About...",                    ID__ABOUT
+        MENUITEM "&About",                   ID__ABOUT
     END
 END
 
 STRINGTABLE 
 BEGIN
-    IDS_APP_TITLE           "Sound recorder"
+    IDS_APP_TITLE           "Sound Recorder"
     IDC_REACTOS_SNDREC32    "REACTOS_SNDREC32"
 END
 
@@ -46,7 +46,7 @@
 BEGIN
     IDS_STRPOS              "Position: %.2f s"
     IDS_STRDUR              "Lenght: %.2f s"
-    IDS_STRBUF              "Buffer: %.2f kb"
+    IDS_STRBUF              "Buffer: %.2f KB"
     IDS_STRFMT              "%.1f kHz %u bits"
     IDS_STRMONO             "mono"
     IDS_STRSTEREO           "stereo"
Index: base/applications/sndrec32/lang/tr-TR.rc
===================================================================
--- base/applications/sndrec32/lang/tr-TR.rc	(revision 0)
+++ base/applications/sndrec32/lang/tr-TR.rc	(working copy)
@@ -0,0 +1,54 @@
+LANGUAGE LANG_TURKISH, SUBLANG_DEFAULT
+
+IDC_REACTOS_SNDREC32 ACCELERATORS
+BEGIN
+    "?",            IDM_ABOUT,              ASCII,  ALT
+    "/",            IDM_ABOUT,              ASCII,  ALT
+END
+
+IDD_ABOUTBOX DIALOGEX 0, 0, 196, 75
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "ReactOS Ses Kaydedicisi Hakkında"
+FONT 8, "MS Shell Dlg", 0, 0, 0x1
+BEGIN
+    ICON            IDI_SNDREC32,-1,19,14,21,20
+    LTEXT           "ReactOS Ses Kaydedicisi, sürüm 1.0",IDC_STATIC,56,16,114,8,SS_NOPREFIX
+    LTEXT           "Tekif Hakkı - 2009",IDC_STATIC,55,25,114,8
+    DEFPUSHBUTTON   "&Tamam",IDOK,139,54,50,14,WS_GROUP
+END
+
+IDR_MENU1 MENU
+BEGIN
+    POPUP "&Kütük"
+    BEGIN
+        MENUITEM "&Yeni",                    ID_NEW
+        MENUITEM "&Aç",                      ID_FILE_OPEN
+        MENUITEM "&Kaydet",                  ID_FILE_SAVE, GRAYED
+        MENUITEM "Ay&rı Kaydet",             ID_FILE_SAVEAS, GRAYED
+        MENUITEM SEPARATOR
+        MENUITEM "&Çıkış",                   ID_EXIT
+    END
+    MENUITEM "Yapılacak",                    0
+    MENUITEM "Yapılacak_2",                  0
+    POPUP "&Yardım"
+    BEGIN
+        MENUITEM "&Hakkında",                ID__ABOUT
+    END
+END
+
+STRINGTABLE 
+BEGIN
+    IDS_APP_TITLE           "Ses Kaydedicisi"
+    IDC_REACTOS_SNDREC32    "REACTOS_SNDREC32"
+END
+
+STRINGTABLE 
+BEGIN
+    IDS_STRPOS              "Konum: %.2f s"
+    IDS_STRDUR              "Uzunluk: %.2f s"
+    IDS_STRBUF              "Nitelik: %.2f KB"
+    IDS_STRFMT              "%.1f kHz, %u bitlik"
+    IDS_STRMONO             "Tek Yol"
+    IDS_STRSTEREO           "Çift Yol"
+    IDS_STRCHAN             "%s"
+END
Index: base/applications/sndrec32/rsrc.rc
===================================================================
--- base/applications/sndrec32/rsrc.rc	(revision 58545)
+++ base/applications/sndrec32/rsrc.rc	(working copy)
@@ -47,14 +47,17 @@
 #ifdef LANGUAGE_PL_PL
     #include "lang/pl-PL.rc"
 #endif
+#ifdef LANGUAGE_RO_RO
+    #include "lang/ro-RO.rc"
+#endif
 #ifdef LANGUAGE_SK_SK
     #include "lang/sk-SK.rc"
 #endif
 #ifdef LANGUAGE_SV_SE
     #include "lang/sv-SE.rc"
 #endif
-#ifdef LANGUAGE_RO_RO
-    #include "lang/ro-RO.rc"
+#ifdef LANGUAGE_TR_TR
+    #include "lang/tr-TR.rc"
 #endif
 #ifdef LANGUAGE_UK_UA
     #include "lang/uk-UA.rc"