Index: base/applications/calc/lang/en-US.rc
===================================================================
--- base/applications/calc/lang/en-US.rc	(revision 58606)
+++ base/applications/calc/lang/en-US.rc	(working copy)
@@ -44,7 +44,7 @@
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
     PUSHBUTTON      "(",IDC_BUTTON_LEFTPAR,64,60,24,18,BS_CENTER |
                     BS_VCENTER | BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
-    PUSHBUTTON      "Exp",IDC_BUTTON_EXP,64,80,24,18,BS_CENTER | BS_VCENTER |
+    PUSHBUTTON      "exp",IDC_BUTTON_EXP,64,80,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
     PUSHBUTTON      "x^y",IDC_BUTTON_XeY,64,100,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
@@ -70,7 +70,7 @@
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
     PUSHBUTTON      "M+",IDC_BUTTON_MP,123,120,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
-    PUSHBUTTON      "pi",IDC_BUTTON_PI,123,140,24,18,BS_CENTER | BS_VCENTER |
+    PUSHBUTTON      "π",IDC_BUTTON_PI,123,140,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
     PUSHBUTTON      "7",IDC_BUTTON_7,156,60,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
@@ -112,7 +112,7 @@
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
     PUSHBUTTON      "D",IDC_BUTTON_D,234,140,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
-    PUSHBUTTON      "Mod",IDC_BUTTON_MOD,260,60,24,18,BS_CENTER | BS_VCENTER |
+    PUSHBUTTON      "mod",IDC_BUTTON_MOD,260,60,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
     PUSHBUTTON      "Or",IDC_BUTTON_OR,260,80,24,18,BS_CENTER | BS_VCENTER |
                     BS_NOTIFY | BS_OWNERDRAW | WS_TABSTOP
@@ -305,10 +305,10 @@
 
 IDD_DIALOG_ABOUT DIALOGEX DISCARDABLE  0, 0, 264, 169
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "About ReactOS Calc"
+CAPTION "About ReactOS Calculator"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    DEFPUSHBUTTON   "OK",IDOK,105,148,52,16
+    DEFPUSHBUTTON   "&OK",IDOK,105,148,52,16
     CONTROL         IDB_BITMAP_ROS,IDC_STATIC,"Static",SS_BITMAP | SS_CENTERIMAGE |
                     SS_REALSIZEIMAGE | WS_BORDER,4,4,104,48
     LTEXT           "ReactOS Calculator",IDC_STATIC,120,12,132,8,
@@ -324,15 +324,15 @@
 
 IDD_DIALOG_STAT DIALOGEX DISCARDABLE  0, 0, 163, 85
 STYLE DS_SHELLFONT | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "Statistics box"
+CAPTION "Statistics Box"
 FONT 8, "MS Shell Dlg"
 BEGIN
     LISTBOX         IDC_LIST_STAT,4,4,156,40,LBS_NOINTEGRALHEIGHT |
                     WS_VSCROLL | WS_TABSTOP
-    PUSHBUTTON      "RET",IDC_BUTTON_RET,4,48,36,16
-    PUSHBUTTON      "LOAD",IDC_BUTTON_LOAD,44,48,36,16
-    PUSHBUTTON      "CD",IDC_BUTTON_CD,84,48,36,16
-    PUSHBUTTON      "CAD",IDC_BUTTON_CAD,124,48,36,16
+    PUSHBUTTON      "&Return",IDC_BUTTON_RET,4,48,36,16
+    PUSHBUTTON      "&Load",IDC_BUTTON_LOAD,44,48,36,16
+    PUSHBUTTON      "&Delete",IDC_BUTTON_CD,84,48,36,16
+    PUSHBUTTON      "Delete &All",IDC_BUTTON_CAD,124,48,36,16
     CTEXT           "n=0",IDC_TEXT_NITEMS,4,68,156,12,SS_CENTERIMAGE |
                     SS_SUNKEN
 END
@@ -341,89 +341,89 @@
 
 IDR_MENU_SCIENTIFIC_1 MENU DISCARDABLE
 BEGIN
-    POPUP "Edit"
+    POPUP "&Edit"
     BEGIN
-        MENUITEM "Copy\tCtrl+C",                IDM_EDIT_COPY
-        MENUITEM "Paste\tCtrl+V",               IDM_EDIT_PASTE
+        MENUITEM "&Copy\tCtrl+C",                IDM_EDIT_COPY
+        MENUITEM "&Paste\tCtrl+V",               IDM_EDIT_PASTE
     END
-    POPUP "View"
+    POPUP "&View"
     BEGIN
-        MENUITEM "Standard",                    IDM_VIEW_STANDARD, CHECKED
-        MENUITEM "Scientific",                  IDM_VIEW_SCIENTIFIC, CHECKED
-        MENUITEM "Conversion",                  IDM_VIEW_CONVERSION
+        MENUITEM "&Standard",                    IDM_VIEW_STANDARD, CHECKED
+        MENUITEM "Sc&ientific",                  IDM_VIEW_SCIENTIFIC, CHECKED
+        MENUITEM "&Conversion",                  IDM_VIEW_CONVERSION
         MENUITEM SEPARATOR
-        MENUITEM "Hex\tF5",                     IDM_VIEW_HEX, CHECKED
-        MENUITEM "Decimal\tF6",                 IDM_VIEW_DEC, CHECKED
-        MENUITEM "Octal\tF7",                   IDM_VIEW_OCT, CHECKED
-        MENUITEM "Binary\tF8",                  IDM_VIEW_BIN, CHECKED
+        MENUITEM "&Hex\tF5",                     IDM_VIEW_HEX, CHECKED
+        MENUITEM "&Decimal\tF6",                 IDM_VIEW_DEC, CHECKED
+        MENUITEM "&Octal\tF7",                   IDM_VIEW_OCT, CHECKED
+        MENUITEM "&Binary\tF8",                  IDM_VIEW_BIN, CHECKED
         MENUITEM SEPARATOR
-        MENUITEM "Degrees\tF2",                 IDM_VIEW_DEG, CHECKED
-        MENUITEM "Radians\tF3",                 IDM_VIEW_RAD, CHECKED
-        MENUITEM "Gradians\tF4",                IDM_VIEW_GRAD, CHECKED
+        MENUITEM "D&egrees\tF2",                 IDM_VIEW_DEG, CHECKED
+        MENUITEM "&Radians\tF3",                 IDM_VIEW_RAD, CHECKED
+        MENUITEM "Gr&adians\tF4",                IDM_VIEW_GRAD, CHECKED
         MENUITEM SEPARATOR
-        MENUITEM "Group digits",                IDM_VIEW_GROUP, CHECKED
+        MENUITEM "&Group Digits",                IDM_VIEW_GROUP, CHECKED
     END
-    POPUP "Help"
+    POPUP "&Help"
     BEGIN
-        MENUITEM "Help topics",                 IDM_HELP_HELP
+        MENUITEM "&Help Topics",                 IDM_HELP_HELP
         MENUITEM SEPARATOR
-        MENUITEM "About ReactOS Calc",          IDM_HELP_ABOUT
+        MENUITEM "&About",                       IDM_HELP_ABOUT
     END
 END
 
 IDR_MENU_SCIENTIFIC_2 MENU DISCARDABLE
 BEGIN
-    POPUP "Edit"
+    POPUP "&Edit"
     BEGIN
-        MENUITEM "Copy\tCtrl+C",                IDM_EDIT_COPY
-        MENUITEM "Paste\tCtrl+V",               IDM_EDIT_PASTE
+        MENUITEM "&Copy\tCtrl+C",                IDM_EDIT_COPY
+        MENUITEM "&Paste\tCtrl+V",               IDM_EDIT_PASTE
     END
-    POPUP "View"
+    POPUP "&View"
     BEGIN
-        MENUITEM "Standard",                    IDM_VIEW_STANDARD, CHECKED
-        MENUITEM "Scientific",                  IDM_VIEW_SCIENTIFIC, CHECKED
-        MENUITEM "Conversion",                  IDM_VIEW_CONVERSION
+        MENUITEM "&Standard",                    IDM_VIEW_STANDARD, CHECKED
+        MENUITEM "Sc&ientific",                  IDM_VIEW_SCIENTIFIC, CHECKED
+        MENUITEM "&Conversion",                  IDM_VIEW_CONVERSION
         MENUITEM SEPARATOR
-        MENUITEM "Hex\tF5",                     IDM_VIEW_HEX, CHECKED
-        MENUITEM "Decimal\tF6",                 IDM_VIEW_DEC, CHECKED
-        MENUITEM "Octal\tF7",                   IDM_VIEW_OCT, CHECKED
-        MENUITEM "Binary\tF8",                  IDM_VIEW_BIN, CHECKED
+        MENUITEM "&Hex\tF5",                     IDM_VIEW_HEX, CHECKED
+        MENUITEM "&Decimal\tF6",                 IDM_VIEW_DEC, CHECKED
+        MENUITEM "&Octal\tF7",                   IDM_VIEW_OCT, CHECKED
+        MENUITEM "&Binary\tF8",                  IDM_VIEW_BIN, CHECKED
         MENUITEM SEPARATOR
-        MENUITEM "Qword\tF12",                  IDM_VIEW_QWORD, CHECKED
-        MENUITEM "Dword\tF2",                   IDM_VIEW_DWORD, CHECKED
-        MENUITEM "Word\tF3",                    IDM_VIEW_WORD, CHECKED
-        MENUITEM "Byte\tF4",                    IDM_VIEW_BYTE, CHECKED
+        MENUITEM "&Qword\tF12",                  IDM_VIEW_QWORD, CHECKED
+        MENUITEM "Dwo&rd\tF2",                   IDM_VIEW_DWORD, CHECKED
+        MENUITEM "&Word\tF3",                    IDM_VIEW_WORD, CHECKED
+        MENUITEM "B&yte\tF4",                    IDM_VIEW_BYTE, CHECKED
         MENUITEM SEPARATOR
-        MENUITEM "Group digits",                IDM_VIEW_GROUP, CHECKED
+        MENUITEM "&Group Digits",                IDM_VIEW_GROUP, CHECKED
     END
-    POPUP "Help"
+    POPUP "&Help"
     BEGIN
-        MENUITEM "Help topics",                 IDM_HELP_HELP
+        MENUITEM "&Help Topics",                 IDM_HELP_HELP
         MENUITEM SEPARATOR
-        MENUITEM "About ReactOS Calc",          IDM_HELP_ABOUT
+        MENUITEM "&About",                       IDM_HELP_ABOUT
     END
 END
 
 IDR_MENU_STANDARD MENU DISCARDABLE
 BEGIN
-    POPUP "Edit"
+    POPUP "&Edit"
     BEGIN
-        MENUITEM "Copy\tCtrl+C",                IDM_EDIT_COPY
-        MENUITEM "Paste\tCtrl+V",               IDM_EDIT_PASTE
+        MENUITEM "&Copy\tCtrl+C",                IDM_EDIT_COPY
+        MENUITEM "&Paste\tCtrl+V",               IDM_EDIT_PASTE
     END
-    POPUP "View"
+    POPUP "&View"
     BEGIN
-        MENUITEM "Standard",                    IDM_VIEW_STANDARD, CHECKED
-        MENUITEM "Scientific",                  IDM_VIEW_SCIENTIFIC, CHECKED
-        MENUITEM "Conversion",                  IDM_VIEW_CONVERSION
+        MENUITEM "&Standard",                    IDM_VIEW_STANDARD, CHECKED
+        MENUITEM "Sc&ientific",                  IDM_VIEW_SCIENTIFIC, CHECKED
+        MENUITEM "&Conversion",                  IDM_VIEW_CONVERSION
         MENUITEM SEPARATOR
-        MENUITEM "Group digits",                IDM_VIEW_GROUP, CHECKED
+        MENUITEM "&Group Digits",                IDM_VIEW_GROUP, CHECKED
     END
-    POPUP "Help"
+    POPUP "&Help"
     BEGIN
-        MENUITEM "Help topics",                 IDM_HELP_HELP
+        MENUITEM "&Help Topics",                 IDM_HELP_HELP
         MENUITEM SEPARATOR
-        MENUITEM "About ReactOS Calc",          IDM_HELP_ABOUT
+        MENUITEM "&About",                       IDM_HELP_ABOUT
     END
 END
 
@@ -431,9 +431,9 @@
 
 STRINGTABLE DISCARDABLE
 BEGIN
-    IDS_STRING_LICENSE      "ReactOS Calc is free software released under GNU GPL license.\r\n\r\nYou can get a copy of GNU GPL license here:\r\nhttp://www.gnu.org/licenses/gpl.html\r\n\r\nYou can also get a translation of GNU GPL license here:\r\nhttp://www.gnu.org/licenses/translations.html"
+    IDS_STRING_LICENSE      "ReactOS Calculator is free software released under GNU GPL license.\r\n\r\nYou can get a copy of GNU GPL license here:\r\nhttp://www.gnu.org/licenses/gpl.html\r\n\r\nYou can also get translations of GNU GPL license here:\r\nhttp://www.gnu.org/licenses/translations.html"
     IDS_MATH_ERROR          "Error"
-    IDS_QUICKHELP           "Quick help"
+    IDS_QUICKHELP           "Quick Help"
 END
 
 // Types of conversion
@@ -536,7 +536,7 @@
 // TYPES OF ENERGIES
 STRINGTABLE DISCARDABLE
 BEGIN
-    IDS_ENERGY_15_C_CALORIES        "15 °C calories"
+    IDS_ENERGY_15_C_CALORIES        "Calories (15°C)"
     IDS_ENERGY_BTUS                 "British Thermal Units"
     IDS_ENERGY_ERGS                 "Ergs"
     IDS_ENERGY_EVS                  "Electron-Volts"