Index: base/applications/rapps/lang/en-US.rc
===================================================================
--- base/applications/rapps/lang/en-US.rc	(revision 58613)
+++ base/applications/rapps/lang/en-US.rc	(working copy)
@@ -4,24 +4,24 @@
 BEGIN
 	POPUP "&File"
 	BEGIN
-		MENUITEM "&Settings", ID_SETTINGS
+		MENUITEM "&Settings...",   ID_SETTINGS
 		MENUITEM SEPARATOR
-		MENUITEM "E&xit",     ID_EXIT
+		MENUITEM "E&xit",          ID_EXIT
 	END
-	POPUP "&Programs"
+	POPUP "&Program"
 	BEGIN
-		MENUITEM "&Install",  ID_INSTALL
-		MENUITEM "&Uninstall",ID_UNINSTALL
-		MENUITEM "&Modify",   ID_MODIFY
+		MENUITEM "&Install",       ID_INSTALL
+		MENUITEM "&Uninstall",     ID_UNINSTALL
+		MENUITEM "&Modify",        ID_MODIFY
 		MENUITEM SEPARATOR
-		MENUITEM "&Remove from Registry", ID_REGREMOVE
+		MENUITEM "&Remove From Registry", ID_REGREMOVE
 		MENUITEM SEPARATOR
-		MENUITEM "&Refresh",  ID_REFRESH
+		MENUITEM "&Refresh",       ID_REFRESH
 	END
-	POPUP "Help"
+	POPUP "&Help"
 	BEGIN
-		MENUITEM "Help",      ID_HELP, GRAYED
-		MENUITEM "About",     ID_ABOUT
+		MENUITEM "&Help Contents", ID_HELP, GRAYED
+		MENUITEM "&About",         ID_ABOUT
 	END
 END
 
@@ -29,8 +29,8 @@
 BEGIN
 	POPUP "popup"
 	BEGIN
-		MENUITEM "&Open link in a browser", ID_OPEN_LINK
-		MENUITEM "&Copy link to clipboard", ID_COPY_LINK
+		MENUITEM "&Open Link in a Browser", ID_OPEN_LINK
+		MENUITEM "&Copy Link to Clipboard", ID_COPY_LINK
 	END
 END
 
@@ -42,7 +42,7 @@
 		MENUITEM "&Uninstall", ID_UNINSTALL
 		MENUITEM "&Modify",    ID_MODIFY
 		MENUITEM SEPARATOR
-		MENUITEM "&Remove from Registry", ID_REGREMOVE
+		MENUITEM "&Remove From Registry", ID_REGREMOVE
 		MENUITEM SEPARATOR
 		MENUITEM "&Refresh",   ID_REFRESH
 	END
@@ -54,43 +54,43 @@
 FONT 8, "MS Shell Dlg"
 BEGIN
 	GROUPBOX "General", -1, 4, 2, 240, 61
-	AUTOCHECKBOX "&Save window position", IDC_SAVE_WINDOW_POS, 15, 12, 219, 12
-	AUTOCHECKBOX "&Update the list of accessible programs at start", IDC_UPDATE_AVLIST, 15, 29, 222, 12
-	AUTOCHECKBOX "&Log of installation and removal of programs", IDC_LOG_ENABLED, 15, 46, 219, 12
+	AUTOCHECKBOX "&Save Window Position", IDC_SAVE_WINDOW_POS, 15, 12, 219, 12
+	AUTOCHECKBOX "&Update the List of Accessible Programs at Start", IDC_UPDATE_AVLIST, 15, 29, 222, 12
+	AUTOCHECKBOX "&Log of Installation and Removal of Programs", IDC_LOG_ENABLED, 15, 46, 219, 12
 
 	GROUPBOX "Downloading", -1, 4, 65, 240, 51
-	LTEXT "Downloads folder:", -1, 16, 75, 100, 9
+	LTEXT "Downloads Folder:", -1, 16, 75, 100, 9
 	EDITTEXT IDC_DOWNLOAD_DIR_EDIT, 15, 86, 166, 12, WS_CHILD | WS_VISIBLE | WS_GROUP
 	PUSHBUTTON "&Choose", IDC_CHOOSE, 187, 85, 50, 14
-	AUTOCHECKBOX "&Delete program installer after installation", IDC_DEL_AFTER_INSTALL, 16, 100, 218, 12
+	AUTOCHECKBOX "&Delete Program Installer After Installation", IDC_DEL_AFTER_INSTALL, 16, 100, 218, 12
 
-	PUSHBUTTON "Default", IDC_DEFAULT_SETTINGS, 8, 124, 60, 14
-	PUSHBUTTON "OK", IDOK, 116, 124, 60, 14
-	PUSHBUTTON "Cancel", IDCANCEL, 181, 124, 60, 14
+	PUSHBUTTON "D&efaults", IDC_DEFAULT_SETTINGS, 8, 124, 60, 14
+	PUSHBUTTON "&OK", IDOK, 116, 124, 60, 14
+	PUSHBUTTON "C&ancel", IDCANCEL, 181, 124, 60, 14
 END
 
 IDD_INSTALL_DIALOG DIALOGEX DISCARDABLE  0, 0, 216, 97
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "Program installation"
+CAPTION "Program Installation"
 FONT 8, "MS Shell Dlg"
 BEGIN
 	LTEXT "...", IDC_INSTALL_TEXT, 4, 5, 209, 35
 
-	AUTORADIOBUTTON "&Install from a disk (CD or DVD)", IDC_CD_INSTALL, 10, 46, 197, 11, WS_GROUP
-	AUTORADIOBUTTON "&Download and install", IDC_DOWNLOAD_INSTALL, 10, 59, 197, 11, NOT WS_TABSTOP
+	AUTORADIOBUTTON "&Install From a Disk", IDC_CD_INSTALL, 10, 46, 197, 11, WS_GROUP
+	AUTORADIOBUTTON "&Download and Install", IDC_DOWNLOAD_INSTALL, 10, 59, 197, 11, NOT WS_TABSTOP
 
-	PUSHBUTTON "OK", IDOK, 86, 78, 60, 14
-	PUSHBUTTON "Cancel", IDCANCEL, 150, 78, 60, 14
+	PUSHBUTTON "&OK", IDOK, 86, 78, 60, 14
+	PUSHBUTTON "&Cancel", IDCANCEL, 150, 78, 60, 14
 END
 
 IDD_DOWNLOAD_DIALOG DIALOGEX LOADONCALL MOVEABLE DISCARDABLE  0, 0, 220, 76
 STYLE DS_SHELLFONT | DS_CENTER | WS_BORDER | WS_CAPTION | WS_POPUP | WS_SYSMENU | WS_VISIBLE
-CAPTION "Download..."
+CAPTION "Downloading"
 FONT 8, "MS Shell Dlg"
 BEGIN
     CONTROL "Progress1", IDC_DOWNLOAD_PROGRESS, "msctls_progress32", WS_BORDER | PBS_SMOOTH, 10, 10, 200, 12
     LTEXT "", IDC_DOWNLOAD_STATUS, 10, 30, 200, 10, SS_CENTER
-    PUSHBUTTON "Cancel", IDCANCEL, 85, 58, 50, 15, WS_GROUP | WS_TABSTOP
+    PUSHBUTTON "&Cancel", IDCANCEL, 85, 58, 50, 15, WS_GROUP | WS_TABSTOP
 END
 
 IDD_ABOUT_DIALOG DIALOGEX 22, 16, 190, 66
@@ -99,7 +99,7 @@
 FONT 8, "MS Shell Dlg"
 BEGIN
 	LTEXT "ReactOS Applications Manager\nCopyright (C) 2009\nby Dmitry Chapyshev (dmitry@reactos.org)", IDC_STATIC, 48, 7, 130, 39
-	PUSHBUTTON "Close", IDOK, 133, 46, 50, 14
+	PUSHBUTTON "&OK", IDOK, 133, 46, 50, 14
 	ICON IDI_MAIN, IDC_STATIC, 10, 10, 7, 30
 END
 
@@ -172,11 +172,11 @@
 STRINGTABLE DISCARDABLE
 BEGIN
 	IDS_APPTITLE "ReactOS Applications Manager"
-	IDS_SEARCH_TEXT "Search..."
+	IDS_SEARCH_TEXT "Search"
 	IDS_INSTALL "Install"
 	IDS_UNINSTALL "Uninstall"
 	IDS_MODIFY "Modify"
-	IDS_APPS_COUNT "Applications count: %d"
+	IDS_APPS_COUNT "Applications Count: %d"
 	IDS_WELCOME_TITLE "Welcome to ReactOS Applications Manager!\n\n"
 	IDS_WELCOME_TEXT "Choose a category on the left, then choose an application to install or uninstall.\nReactOS Web Site: "
 	IDS_WELCOME_URL "http://www.reactos.org"