Index: base/applications/charmap/lang/tr-TR.rc
===================================================================
--- base/applications/charmap/lang/tr-TR.rc	(revision 0)
+++ base/applications/charmap/lang/tr-TR.rc	(working copy)
@@ -0,0 +1,49 @@
+LANGUAGE LANG_TURKISH, SUBLANG_DEFAULT
+
+IDD_CHARMAP DIALOGEX 6, 6, 292, 224
+FONT 8,"MS Shell Dlg",0,0
+STYLE DS_SHELLFONT | WS_CHILD | WS_VISIBLE
+BEGIN
+  LTEXT         "Yazı Türü:", IDC_STATIC, 6, 7, 24, 9
+  COMBOBOX      IDC_FONTCOMBO, 36, 5, 210, 210, WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST | CBS_SORT | CBS_HASSTRINGS
+  PUSHBUTTON    "Yardım", IDC_CMHELP, 249, 5, 35, 13
+  CONTROL       "", IDC_FONTMAP, "FontMapWnd", WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL, 20, 22, 266, 156
+  LTEXT         "Çoğaltılacak Damgalar:", IDC_STATIC, 6, 188, 66, 9
+  CONTROL       "",IDC_TEXTBOX,RICHEDIT_CLASS,ES_AUTOHSCROLL | WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP, 74, 186, 114, 13
+  DEFPUSHBUTTON "Seç", IDC_SELECT, 194, 186, 44, 13
+  PUSHBUTTON    "Çoğalt", IDC_COPY, 242, 186, 44, 13, WS_DISABLED
+  CONTROL       "Gelişmiş Görünüm",IDC_CHECK_ADVANCED,"Button", BS_AUTOCHECKBOX | WS_TABSTOP, 8, 208, 95, 10
+END
+
+IDD_ADVANCED DIALOGEX  0, 0, 292, 64
+STYLE DS_SHELLFONT | WS_CHILD
+FONT 8, "MS Shell Dlg"
+BEGIN
+  LTEXT         "Damga Kümesi:",IDC_STATIC,8,8,48,8
+  COMBOBOX      IDC_COMBO_CHARSET,72,4,116,80,CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP
+  LTEXT         "Takımla:",IDC_STATIC,8,28,50,8
+  COMBOBOX      IDC_COMBO_GROUPBY,72,24,116,80,CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP
+  PUSHBUTTON    "Ara",IDC_BUTTON_SEARCH,200,44,50,14
+  EDITTEXT      IDC_EDIT_SEARCH,72,44,116,14,ES_AUTOHSCROLL
+  LTEXT         "Ada Göre Ara:",IDC_STATIC,8,48,42,8
+  LTEXT         "Unikod:",IDC_STATIC,200,8,30,8
+  EDITTEXT      IDC_EDIT_UNICODE,236,4,28,12,ES_AUTOHSCROLL
+END
+
+IDD_ABOUTBOX DIALOGEX 22,16,210,182
+CAPTION "Karakter Eşlem Hakkında"
+FONT 8,"MS Shell Dlg",0,0
+STYLE DS_SHELLFONT | WS_BORDER | WS_DLGFRAME | WS_SYSMENU | DS_MODALFRAME
+BEGIN
+  LTEXT         "Karakter Eşlem, Sürüm 0.1\nTelif Hakkı: 2007 - Ged Murphy (gedmurphy@reactos.org)", IDC_STATIC, 48, 7, 150, 36
+  PUSHBUTTON    "Tamam", IDOK, 75, 162, 44, 15
+  ICON          IDI_ICON, IDC_STATIC, 10, 10, 7, 30
+  EDITTEXT      IDC_LICENSE_EDIT, 8, 44, 194, 107, WS_VISIBLE | WS_VSCROLL | WS_TABSTOP | ES_READONLY | ES_MULTILINE
+END
+
+STRINGTABLE DISCARDABLE
+BEGIN
+  IDS_LICENSE   "ÖNEMLİ: Aşağıdaki metin özgün metnin resmî olmayan çevirisidir. Çeviri metniyle özgün metin arasında ayrım olabilir. Özgün metin çeviri metninin altındadır.\r\n\r\n***\r\n\r\nBu yazılım özgürdür, yani bu yazılım Özgür Yazılım Vakfı'nın yayınladığı GNU Genel Kamu Lisansı'nın 2. sürümü veya daha sonraki sürümleri altında yeniden dağıtabilir veya değiştirebilirsiniz.\r\n\r\nBu yazılım, kullanışlı olabileceği umuduyla dağıtılmıştır, ancak özellikle SATILABİLİRLİK ve BELİRLİ BİR AMACA UYGUNLUK açısından olmak üzere bu yazılımın hiçbir güvencesi yoktur. Daha fazla bilgi için GNU Genel Kamu Lisansı'na bakınız.\r\n\r\nBu yazılımla birlikte GNU Genel Kamu Lisansı'nın bir sûretine de iye olmanız gerekir, eğer yoksa Özgür Yazılım Vakfı A.Ş.'ne (51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 ABD) yazınız.\r\n\r\n***\r\n\r\nThis program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.\r\n\r\nThis program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.\r\n\r\nYou should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA."
+  IDS_ABOUT     "&Hakkında..."
+  IDS_TITLE     "Karakter Eşlem"
+END
Index: base/applications/charmap/rsrc.rc
===================================================================
--- base/applications/charmap/rsrc.rc	(revision 58739)
+++ base/applications/charmap/rsrc.rc	(working copy)
@@ -66,6 +66,9 @@
 #ifdef LANGUAGE_SV_SE
     #include "lang/sv-SE.rc"
 #endif
+#ifdef LANGUAGE_TR_TR
+    #include "lang/tr-TR.rc"
+#endif
 #ifdef LANGUAGE_UK_UA
     #include "lang/uk-UA.rc"
 #endif